#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>

/* Function to process the numbers and print the results */
void print_results(int count, unsigned long int total, unsigned long int max_value) {
    if (count == 0) {
        fprintf(stderr, "No numbers found in the file.\n");
        return;
    }

    double average = (double) total / count;
    fprintf(stderr, "Count: %d\n", count);
    fprintf(stderr, "Total: %lu\n", total);
    fprintf(stderr, "Average: %.2f\n", average);
    fprintf(stderr, "Maximum: %lu\n", max_value);
}

int main(int argc, char *argv[]) {
    if (argc != 3 || strcmp(argv[1], "-i") != 0) {
        fprintf(stderr, "Usage: %s -i input-file\n", argv[0]);
        return EXIT_FAILURE;
    }

    /* Open the input file */
    FILE *file = fopen(argv[2], "r");
    if (!file) {
        perror("Error opening file");
        return EXIT_FAILURE;
    }

    int count = 0;
    unsigned long int total = 0, max_value = 0, num;

    /* Read numbers from the file */
    while (fscanf(file, "%lu", &num) == 1) {
        count++;
        total += num;
        if (num > max_value) {
            max_value = num;
        }
    }

    fclose(file);

    /* Print results */
    print_results(count, total, max_value);

    return EXIT_SUCCESS;
}
